"""


"""

from direct.showbase import DirectObject

class TickController(DirectObject.DirectObject):
    
    def __init__(self):
        self.keepGoing = 1
        
        self.gameTask = taskMgr.add(self.Run, "gameLoop")
        self.gameTask.last = 0    #Task time of the last frame
        
        # Register listening
        self.accept("QuitEvent", self.Stop)
        self.accept("PauseEvent", self.Stop)
        self.accept("UnpauseEvent", self.Start)        
        
    def Run(self, task):

        dt = globalClock.getDt()

        messenger.send("RealTickEvent", [dt])

        if self.keepGoing:
            messenger.send("TickEvent", [dt])
            
        return task.cont
        
    def Stop(self):
        self.keepGoing = 0

    def Start(self):
        self.keepGoing = 1